
void resetDisplay(void);
void DigShow(void);
int digiRead(int PinNr);
int xdecimal(char was);

struct Seg7 {
    char disp;
    String pin;
  };


// translation table: pin of the 7 segment display to Arduino digital pin 
int TransSeg7ArdPin[10] = {2,3,0,4,5,6,7,0,8,9};
  
// definitios of pins to set HIGH according to the desired number (A = 10)
Seg7 Seg7Char[11] = { 
  {'0', "124679"},
  {'1', "46"},
  {'2', "12A67"},
  {'3', "24A67"},
  {'4', "4A69"},
  {'5', "24A79"},
  {'6', "124A79"},
  {'7', "467"},
  {'8', "124A679"},
  {'9', "24A679"},
  {'P', "5"} // decimal point
};


int DigNumber[10][8] = {
  {1,1,1,0,1,1,1,0},
  {0,0,1,0,1,0,0,0},
  {1,1,0,0,1,1,0,1},
  {0,1,1,0,1,1,0,1},
  {0,0,1,0,1,0,1,1},
  {0,1,1,0,0,1,1,1},
  {1,1,1,0,0,1,1,1},
  {0,0,1,0,1,1,0,0},
  {1,1,1,0,1,1,1,1},
  {0,1,1,0,1,1,1,1} };

int xa; // counter
int actNumber; // actual value to display
char char2disp;

 // Test
void test(void)
{
  char show1 = '4';
  int xb, xc, xmax = 0;
  
  Serial.begin(9600);

  xa = 0;
  while(xa <= 9 && Seg7Char[xa].disp != show1)
    xa++;
    
  Serial.println(Seg7Char[xa].pin);
  xmax = Seg7Char[xa].pin.length() - 1;
  for (xb = 0; xb <= xmax; xb++) {
    xc = xdecimal(Seg7Char[xa].pin.charAt(xb));

    Serial.println(xc);
  }      
}   


void setup() 
{

Serial.begin(9600);
 
  // test();
 
  // initialize digital pins 2 to 9 as an output for 7 segment display (+ 1 for decimal point).
  for (xa = 2; xa <= 9; xa++)
    pinMode(xa, OUTPUT);    

  // initialize digital pin 10 and 11 as an input, 10 = increment the number to display, 11 = reset (all segments off)
  pinMode(10, INPUT);
  pinMode(11, INPUT);
  actNumber = 0;
  resetDisplay();
  
}

// the loop function runs over and over again forever
void loop() 
{

  if (digiRead(10) == HIGH)
  {  
    char2disp = '6'; //char(actNumber);
    DigShow();
    // DigShow('2');
    actNumber++;
    if (actNumber > 9) actNumber = 0;

  }     
  
  if (digiRead(11) == HIGH)
    resetDisplay();     
  
}

void resetDisplay(void)
{
  int xb;
  // set all digital outputs of the table to LOW, except 0
  for (xa = 0; xa <= 9; xa++) {
    xb = TransSeg7ArdPin[xa];
    if (xb != 0)
      digitalWrite(TransSeg7ArdPin[xb], LOW);    // turn the LED off by making the voltage LOW 
  }
    
  // lit up the decimal point for half a second  
  digitalWrite(TransSeg7ArdPin[4], HIGH);  
  delay(300);
  digitalWrite(TransSeg7ArdPin[4], LOW);
  
}

void DigShow(void)
{
  int xb, xc, xmax = 0;
 
  // set all digital outputs of the table to LOW, except 0
  for (xa = 0; xa <= 9; xa++) {
    xb = TransSeg7ArdPin[xa];
    if (xb != 0)
    digitalWrite(TransSeg7ArdPin[xb], LOW);    // turn the LED off by making the voltage LOW
  }



  xa = 0;
  while(xa <= 9 && Seg7Char[xa].disp != char2disp) {
    xa++;

  }
  

  xmax = Seg7Char[xa].pin.length() - 1;
  for (xb = 0; xb <= xmax; xb++) {
    
    xc = xdecimal(Seg7Char[xa].pin.charAt(xb));
    digitalWrite(TransSeg7ArdPin[xc - 1], HIGH);
    
  
  }
}
  
int digiRead(int PinNr)
{
  int digiResult;

  digiResult = digitalRead(PinNr);
  delay(50);
  return digiResult;
  
}    

// turn a hexadecimal char into integer (allowed letters '0' to '9', 'a' to 'f' or 'A' to 'F')   
int xdecimal(char was)
{
  int retval;

  retval = (int)toupper(was) - 48;
  if (retval >= 17) retval -= 7;

  return retval;
}
